package com.chinaitop.depot.intelligent.common;


/**
 * 结果枚举
 */
public enum ResultEnum {
    /**
     * 操作成功！
     */
    CODE_1(200, "操作成功！"),
    /**
     * 操作失败！
     */
    CODE_2(600, "操作失败！"),
    /**
     * 调用xxx服务失败！
     */
    CODE_3(3, "调用xxx服务失败！"),
    /**
     * 验证码错误或已过期！
     */
    CODE_4(4, "验证码错误或已过期！"),
    /**
     * 用户名或者密码错误！
     */
    CODE_5(5, "用户名或者密码错误！"),
    /**
     * 账号已存在！
     */
    CODE_6(6, "账号已存在！"),
    /**
     * 该client_id不存在
     */
    CODE_7(7, "该client_id不存在！"),
    /**
     * 文件格式不正确！
     */
    CODE_10(10, "文件格式不正确！"),
    /**
     * 业务常量2开头 --------------
     */
    /**
     * 测温类型(检测类型0测温，1粮油,2测水分)
     */
    CODE_20(20, "查询类型不能为空数据(包含测温,粮油,水分)等数据！"),
    /**
     * token无效！
     */
    CODE_401(401, "token无效！"),
    /**
     * 抱歉，您没有访问权限！
     */
    CODE_403(403, "抱歉，您没有访问权限！"),

    CODE_500(500, "服务器出错了，请联系后台开发人员！"),
    /**
     * 请求超时，请稍后再试！
     */
    CODE_504(504, "请求超时，请稍后再试！"),

    /**
     * 服务器神游中！
     */
    CODE_666(666, "服务器神游中！");


    /**
     * 状态码
     */
    private Integer code;

    /**
     * 消息
     */
    private String msg;

    ResultEnum(Integer code, String msg) {
        this.code = code;
        this.msg = msg;
    }

    public Integer getCode() {
        return code;
    }

    public void setCode(Integer code) {
        this.code = code;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }
}