package com.chinaitop.depot.intelligent.grainsituation.service;

import com.chinaitop.depot.intelligent.grainsituation.model.TTestdata;
import com.chinaitop.depot.intelligent.grainsituation.model.TTestdataLayer;
import com.chinaitop.depot.intelligent.grainsituation.model.TempMetadata;
import org.apache.ibatis.annotations.Param;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

public interface TemperatureRecordService {
    List<TTestdata> getList(String vCfCode, String vDatatime, String startTime, String endTime,String tType,String orgId);

    List<TTestdataLayer> findByHouseAndTime(String lqId,String vCfCode, String vDatatime);

    ArrayList<Object> findByHouseAndTimes(String lqId,String vCfCode, String vDatatime, boolean viewFlag);

    List<TTestdata> getComparison(String vCfCodeLeft, String startTimeLeft, String endTimeLeft, String vCfCodeRight, String startTimeRight, String endTimeRight, String tType);

    void insertBatch(List<TTestdata> testData);

    List<TTestdata> getByCodeAndTimes(List<String> cDcsCodes,List<Date> cTimes,List<String> lqTypes);

    String getOrgId (String cfCode);

    TTestdata getById(String id);

    /**
     * 根据id获取带标杆号温度表格
     * @param id
     * @return
     */
    Map<Integer,List<TempMetadata>> findByTempTable(String id);

    /**
     * 分页列表数据(温湿度检测只显示当天数据,按仓房排序)
     * @param vCfCode
     * @param vDatatime
     * @param tType
     * @param orgId
     * @return
     */
    List<TTestdata> getListOfGroup(String vCfCode, String vDatatime, String tType, String orgId);

    List<TTestdata> getTemHistoryPageInfoList(String vCfCode, String vDatatime, String startTime, String endTime, String tType, String orgId);

    Map<String,Object> getMaxAndMinDot(String id);
}
