/*
package com.chinaitop.depot.intelligent.oilTemperatureDetection.controller;

import com.chinaitop.depot.intelligent.grainsituation.model.TTestdata;
import com.chinaitop.depot.intelligent.grainsituation.model.TTestdataLayer;
import com.chinaitop.depot.intelligent.grainsituation.service.TPointsService;
import com.chinaitop.depot.intelligent.grainsituation.service.TemperatureRecordService;
import com.chinaitop.depot.intelligent.oilTemperatureDetection.model.TOiltank;
import com.chinaitop.depot.intelligent.oilTemperatureDetection.service.OilTemperatureService;
import com.chinaitop.depot.intelligent.socket.SocketClient;
import com.chinaitop.depot.intelligent.utils.ConstUtils;
import com.chinaitop.depot.intelligent.utils.HexConvertUtils;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.unissoft.model.ResponseEntity;
import com.unissoft.model.TypeEnum;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping(value = "/intelligents/oilTemperatureDetection")
@Api(value = "OilTemperatureController", description = "油温记录控制类")
@SuppressWarnings("all")
public class OilTemperatureController {

    @Autowired
    private OilTemperatureService oilTemperatureService;


    @RequestMapping(value = "/getList", method = RequestMethod.GET)
    @ApiOperation(value = "查询 油温 信息列表", notes = "查询 油温 信息列表，支持分页")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页码", paramType = "query"),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", paramType = "query"),
            @ApiImplicitParam(name = "vDatatime", value = "采集时间", paramType = "query"),
            @ApiImplicitParam(name = "startTime", value = "开始时间", paramType = "query"),
            @ApiImplicitParam(name = "endTime", value = "结束时间", paramType = "query"),
            @ApiImplicitParam(name = "vCfCode", value = "仓库名称", paramType = "query")
    })
    public ResponseEntity<PageInfo<TOiltank>> getList(Integer pageNum, Integer pageSize, String vCfCode, String vDatatime, String startTime, String endTime, String orgId) {
        List<TOiltank> list = null;
        try {
            if (null != pageNum && null != pageSize) {
                PageHelper.startPage(pageNum, pageSize);
            }
            list = oilTemperatureService.getList(vCfCode, vDatatime, startTime, endTime, orgId);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseEntity.failed(e.getMessage());
        }
        PageInfo<TOiltank> pageInfo = new PageInfo<TOiltank>(list);
        return ResponseEntity.ok(pageInfo);
    }

    */
/**
     * orgid下的所有仓房粮情检测
     *
     * @param storeCode
     * @return
     *//*

    @Autowired
    private SocketClient socketClient;
    @Autowired
    private ConstUtils constUtils;

    @RequestMapping(value = "/sendOilTemperatureDetectionAll", method = RequestMethod.GET)
    @ApiOperation(value = "所有仓油温实时检测", notes = "所有仓油温实时检测")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "tType", value = "油温", paramType = "query")
    })
    public ResponseEntity sendOilTemperatureDetectionAll(String tType) {
        // 比如获取所有仓粮情的指令为：7E 0005 02 0101 0000000000，
        // 那获取所有水位数据是：7E 0005 0E 0101 0000000000
        byte[] b = new byte[11];
        b[0] = 0x7E;
        b[1] = 0x00;
        b[2] = 0x05;
        */
/*if (tType.equals("0")) {
            b[3] = 0x02;
        } else {
            b[3] = 0X0E;
        }*//*

        if ("2".equals(tType)){ // 油情油温类型为2
            b[3] = 0x04; // socket协议油情数据采集(0X04)
        } else {
            b[3] = 0x02; // socket协议粮情数据采集(0x02)
        }
        b[4] = 0x01;
        b[5] = 0x01;
        b[6] = 0x00;
        b[7] = 0x00;
        b[8] = 0x00;
        b[9] = 0x00;
        b[10] = 0x00;
        String result = "";
        // 发送指令
        try {
            String s = socketClient.startClient(b);
            // 0：失败；1：成功；2：设备通讯异常；3：设备故障；4：未知原因; 5: 本地模式(有的设备有本地模式，即无法远程控制)
            result = TypeEnum.resultDispose(s);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseEntity.ok("设备连接异常！");
        } finally {
        }
        return ResponseEntity.ok(result);
    }

    */
/**
     * 单仓检测接口
     *
     * @param storeCode
     * @return
     *//*

    @RequestMapping(value = "/sendOnlyStoreDetection", method = RequestMethod.POST)
    @ApiOperation(value = "单仓油温实时检测", notes = "单仓油温实时检测")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "storeCode", defaultValue = "001", value = "仓库编号", paramType = "query"),
            @ApiImplicitParam(name = "tType", value = "油温检测", paramType = "query")
    })
    public ResponseEntity sendOnlyStoreDetection(String storeCode, String tType) {
        String result = "";
        try {
            if (StringUtils.isNotBlank(storeCode) && StringUtils.isNotBlank(tType)) {
                // 0X02粮情数据采集,仓房号,设备编号若为0则控全部
                String type = "";
                */
/*if (tType.equals("0")) {
                    type = constUtils.GRAIN_TYPE;
                } else {
                    type = constUtils.DEW_TYPE;
                }*//*

                if ("2".equals(tType)){ // 2对应前端js传参表示为油温油情
                    type = constUtils.OIL_TYPE;
                } else {
                    type = constUtils.GRAIN_TYPE;
                }
                String dir = constUtils.directiveJoint(constUtils.F_EXTENT, constUtils.F_SUB_P, type, storeCode, "");
                // 16进制字符串转byte数组
                byte[] bytes = HexConvertUtils.hexStringToByte(dir);
                // 发送指令
                String s = socketClient.startClient(bytes);
                result = TypeEnum.resultDispose(s);
            }
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseEntity.ok("设备连接异常！");
        }
        return ResponseEntity.ok(result);
    }
}
*/
