package com.chinaitop.depot.intelligent.oilTemperatureDetection.service.impl;

import com.chinaitop.depot.intelligent.oilTemperatureDetection.mapper.TOiltankMapper;
import com.chinaitop.depot.intelligent.oilTemperatureDetection.model.TOiltank;
import com.chinaitop.depot.intelligent.oilTemperatureDetection.model.TOiltankExample;
import com.chinaitop.depot.intelligent.oilTemperatureDetection.service.OilTemperatureService;
import com.chinaitop.depot.intelligent.utils.DateUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@SuppressWarnings("all")
@Service
public class OilTemperatureServiceImpl implements OilTemperatureService {
    @Resource
    private TOiltankMapper oiltankMapper;

    @Override
    public List<TOiltank> getList(String vCfCode, String vDatatime, String startTime, String endTime, String orgId) {
        TOiltankExample example = new TOiltankExample();
        example.setDistinct(true);
        TOiltankExample.Criteria criteria = example.createCriteria();
        if (StringUtils.isNotEmpty(vCfCode)) {
            criteria.andOiltankCodeEqualTo(vCfCode);
        }
        if (StringUtils.isNotEmpty(vDatatime)) {
            criteria.andTTimeBetween(DateUtils.stringToData(vDatatime + DateUtils.startTime), DateUtils.stringToData(vDatatime + DateUtils.endTime));
        }
        if (StringUtils.isNotBlank(startTime) && StringUtils.isNotBlank(endTime)) {
            criteria.andTTimeBetween(DateUtils.stringToData(startTime + DateUtils.startTime), DateUtils.stringToData(endTime + DateUtils.endTime));
        }
        if (StringUtils.isNotEmpty(orgId)) {
            criteria.andOrgIdEqualTo(orgId);
        }
        example.setOrderByClause("t_time desc");
        return oiltankMapper.selectByExample(example);
    }
}
