package com.chinaitop.depot.intelligent.utils;

import com.chinaitop.depot.intelligent.basicdata.mapper.TLqinfoMapper;
import com.chinaitop.depot.intelligent.basicdata.model.TLqinfoExample;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

/**
 * @author qingsong.han
 * @description: 进度条处理工具
 * @create 2020-03-11 12:18
 */
@Component
public class ProgressBarUtil {

    @Resource
    private TLqinfoMapper lqinfoMapper;

    public float typeIf(String detType, String cfNum, String orgId) {
        float progress = 0;
        if ("0".equals(detType)) { // 全仓"0"
            progress = 100F/storeNumber(orgId, "");
        } else if ("1".equals(detType)) { // 手动选仓"1"
            progress = 100F/cfNum.split(",").length;
        } else if ("2".equals(detType)) { // 单仓"2"
            progress = 50;
        }
        return progress;
    }

    /**
     * 封装查询,查看有设备得仓房个数
     *
     * @param orgId  所在单位
     * @param cfCode 仓房编号
     * @return int
     */
    private int storeNumber(String orgId, String cfCode) {
        // 查询设备个数
        TLqinfoExample example = new TLqinfoExample();
        TLqinfoExample.Criteria criteria = example.createCriteria();
        criteria.andDelFlagEqualTo(1);//未删除
        criteria.andOrgIdEqualTo(orgId);
        if (StringUtils.isNotBlank(cfCode)) {
            criteria.andVcfcodeEqualTo(cfCode);
        }
        return lqinfoMapper.countByExample(example);
    }

/*
    public static void main(String[] args) {
        Map<String,String> map = new HashMap<>();
        map.put("counter","100");
        map.put("known","20");
        JedisPool pool = new JedisPool("127.0.0.1",6379);
//        Jedis jedis = new Jedis("127.0.0.1",6379);
        Jedis jedis = pool.getResource();
        jedis.hmset("progressBarObj",map);
        jedis.expire("progressBarObj", 30);//设置时效实现 秒

        List<String> progressBarObj = jedis.hmget("progressBarObj","counter","known");
        System.out.println(progressBarObj);
        jedis.close();
    }*/
}
