package com.chinaitop.depot.intelligent.utils;

import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

/**
 * @author qingsong.han
 * @description: 解析xml 字符串头
 * @create 2020-11-18 18:37
 */
public class StringXmlUtil {

    /**
     * 解析xml头字符串参数, 解析get请求返回
     *
     * @param strXML
     * @return
     */
    public static String getStringXmlHead(String strXML) {
        String stringValue = "";
        try {
            Document doc = DocumentHelper.parseText(strXML);
            Element root = doc.getRootElement();// 指向根节点
            stringValue = root.getStringValue();
        } catch (DocumentException e) {
            e.printStackTrace();
        }
        return stringValue;
    }

    /**
     * 解析xml字符串参数, 解析post请求返回
     *
     * @param strXML
     * @return
     */
    public static Map<String, Object> postStringXmlHead(String strXML) {
        Map<String, Object> result = new HashMap<>();
        try {
            Document doc = DocumentHelper.parseText(strXML);
            Element root = doc.getRootElement();// 指向根节点
            Iterator it = root.elementIterator();
            // 获取Body节点
            while (it.hasNext()) {
                Element element = (Element) it.next();
                Iterator elementIterator = element.elementIterator();
                // 获取setBaseDATA等方法节点
                while (elementIterator.hasNext()) {
                    Element element1 = (Element) elementIterator.next();
                    Iterator iterator1 = element1.elementIterator();
                    // 获取key,value 参数值
                    while (iterator1.hasNext()) {
                        Element element2 = (Element) iterator1.next();
                        result.put(element2.getName(), element2.getTextTrim());
                    }
                }
            }
        } catch (DocumentException e) {
            e.printStackTrace();
        }
        return result;
    }

    /*public static void main(String[] args) {
        String s = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n" +
                "<soap12:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap12=\"http://www.w3.org/2003/05/soap-envelope\">\n" +
                "  <soap12:Body>\n" +
                "    <setBaseDATA xmlns=\"http://tempuri.org/\">\n" +
                "      <key>string</key>\n" +
                "      <CF>string</CF>\n" +
                "      <ZBS>string</ZBS>\n" +
                "      <DELV>string</DELV>\n" +
                "      <RKDate>string</RKDate>\n" +
                "      <CCLX>string</CCLX>\n" +
                "      <DZFS>string</DZFS>\n" +
                "      <XZ>string</XZ>\n" +
                "      <R0>string</R0>\n" +
                "      <S0>string</S0>\n" +
                "      <S1>string</S1>\n" +
                "      <Z0>string</Z0>\n" +
                "      <BWSLL>string</BWSLL>\n" +
                "      <LSPZ>string</LSPZ>\n" +
                "      <TFCS>string</TFCS>\n" +
                "      <TSQK>string</TSQK>\n" +
                "    </setBaseDATA>\n" +
                "  </soap12:Body>\n" +
                "</soap12:Envelope>";

        String s1 = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n" +
                "<soap:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\">\n" +
                "  <soap:Body>\n" +
                "    <setBaseDATAResponse xmlns=\"http://tempuri.org/\">\n" +
                "      <setBaseDATAResult>string</setBaseDATAResult>\n" +
                "    </setBaseDATAResponse>\n" +
                "  </soap:Body>\n" +
                "</soap:Envelope>";

        Map<String, Object> map = postStringXmlHead(s1);
        map.forEach((k,v) -> {
            System.out.println(k+" :" + v);
        });
    }*/

}
