package com.chinaitop.depot.intelligent.ventilation.controller;

import com.chinaitop.depot.intelligent.utils.JsonToObjectUtils;
import com.chinaitop.depot.intelligent.ventilation.model.TAerationWarning;
import com.chinaitop.depot.intelligent.ventilation.service.ScheduleService;
import com.unissoft.model.ResponseEntity;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


@RestController
@RequestMapping(value = "/intelligents/scheduleAeration")
@Api(value = "ScheduleController", description = "根据通风规则自动通风")
public class ScheduleController {

    @Autowired
    private ScheduleService scheduleService;

    //每隔一小时检查规则  符合就通风
    @RequestMapping(value = "/sceduleCheck", method = RequestMethod.POST)
    @ApiOperation(value = "查询 通风规则列表", notes = "查询 通风规则列表，支持分页")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "orgId", value = "组织id", paramType = "query")
    })
    public ResponseEntity<String> sceduleCheck(Integer orgId){
        
        /**
         * 判断该粮库中有无通风的规则：
         * 1、有通风规则
         * --1判断该规则是处于打开还是关闭
         *    (关闭状态:查询此时该仓房的该设备是否在通风规则的状态下通风，通风中就关闭，没有通风不处理；
         *     打开状态:判断是否通风：
         *     是: 则要根据设置的通风间隔时间去进行温湿度的检测，如果符合条件则继续通风，否则停止通风
			        否:1、判断该仓房最近2小时之内的温湿度情况与规则进行对比，全部满足就通风，否则不通风
				  2、如果通风，则要根据设置的通风间隔时间去进行温湿度的检测，如果符合条件则继续通风，否则停止通风)
         * 
         * 2、无通风规则
         * --1不处理
         */
    	ResponseEntity<String> result = scheduleService.sceduleCheckTf(orgId);
    	return result;
    }
    	
    
    //新增成功调用
    @RequestMapping(value = "/addAeration", method = RequestMethod.POST)
    @ApiOperation(value = "查询 通风规则列表", notes = "查询 通风规则列表，支持分页")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "aerationRuleJson", value = "新增的规则", paramType = "query")
    })
   public ResponseEntity<String> getList(String aerationRuleJson) {
    	//ResponseEntity result = ResponseEntity.ok();
			TAerationWarning tAerationWarning = (TAerationWarning) JsonToObjectUtils.jsonToObject(aerationRuleJson, "com.chinaitop.depot.intelligent.ventilation.model.TAerationWarning");
			ResponseEntity<String> result = scheduleService.zntf(tAerationWarning);
        return result;
    }
    
}
