package com.chinaitop.depot.intelligent.ventilation.service.impl;





import java.math.BigDecimal;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

import javax.annotation.Resource;

import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.chinaitop.depot.intelligent.grainsituation.mapper.TTestdataMapper;
import com.chinaitop.depot.intelligent.grainsituation.model.TTestdata;
import com.chinaitop.depot.intelligent.grainsituation.model.TTestdataExample;
import com.chinaitop.depot.intelligent.socket.SocketClient;
import com.chinaitop.depot.intelligent.utils.ConstUtils;
import com.chinaitop.depot.intelligent.utils.HexConvertUtils;
import com.chinaitop.depot.intelligent.utils.UuidUtils;
import com.chinaitop.depot.intelligent.ventilation.mapper.TCtldevinfoMapper;
import com.chinaitop.depot.intelligent.ventilation.mapper.TVentilationMapper;
import com.chinaitop.depot.intelligent.ventilation.model.TAerationWarning;
import com.chinaitop.depot.intelligent.ventilation.model.TCtldevinfo;
import com.chinaitop.depot.intelligent.ventilation.model.TCtldevinfoExample;
import com.chinaitop.depot.intelligent.ventilation.model.TVentilation;
import com.chinaitop.depot.intelligent.ventilation.model.TVentilationExample;
import com.chinaitop.depot.intelligent.ventilation.service.ScheduleService;
import com.chinaitop.depot.intelligent.ventilation.service.TAerationWarningService;
import com.unissoft.model.ResponseEntity;
import com.unissoft.model.TypeEnum;



@Service
public class ScheduleServiceImpl implements ScheduleService {
   /* @Autowired
    private TAerationWarningMapper tAerationWarningMapper;*/
    @Autowired
    private TCtldevinfoMapper tCtldevinfoMapper;
    @Autowired
    private TVentilationMapper tVentilationMapper;
    @Autowired
    private TTestdataMapper tTestdataMapper;
    /*@Autowired
    private AerationRecordService aerationRecordService;*/
    @Autowired
    private TAerationWarningService tAerationWarningService;
    @Autowired
    private SocketClient socketClient;
    @Resource
    private UuidUtils uUidUtils;
    
    
	@Override
	public ResponseEntity<String> zntf(TAerationWarning tAerationWarning) {

		String zntfId = tAerationWarning.getId();
	 String result = "";
	 if(tAerationWarning.getwState().equals("1")){ //规则是打开状态
			/**
			 * 1、判断该仓房最近2小时之内的该仓房温湿度情况与规则进行对比，全部满足就通风，否则不通风
			 *(如果通风，则要根据设置的通风间隔时间去进行温湿度的检测，如果符合条件则继续通风，否则停止通风)
			 */
		 TTestdataExample testdataExample = new TTestdataExample();
	        testdataExample.setDistinct(true);
	        TTestdataExample.Criteria criteria = testdataExample.createCriteria();
	        //组织id
	        if (StringUtils.isNotEmpty(tAerationWarning.getOrgId().toString())) {
	            criteria.andOrgIdEqualTo(tAerationWarning.getOrgId().toString());
	        }
	        //仓房
	        if (StringUtils.isNotEmpty(tAerationWarning.getvCfCode())) {
	            criteria.andStorehouseEqualTo(tAerationWarning.getvCfCode());
	        }
	        //获取两小时之内的粮情数据
	        Date date=new Date(); 
	        Calendar calendar = Calendar.getInstance(); 
	        calendar.setTime(date);
	        calendar.add(Calendar.HOUR_OF_DAY, -2);  
	        Date date1 = calendar.getTime();  
	        criteria.andTimeBetween(date1, date);
	        //粮情
	        if (StringUtils.isNotEmpty("0")) {
	            criteria.andIlqYqEqualTo("0");
	        }
	        testdataExample.setOrderByClause("time desc");
	        List<TTestdata> tTestList = tTestdataMapper.selectByExample(testdataExample);
	        if(tTestList!=null && tTestList.size()>0){
	        	 BigDecimal YcAmount = new BigDecimal("250"); //异常的
	        	for (TTestdata tTestdata : tTestList) {//查询出两小时之内的数据，取最近的一条数据都为正常的 自取一条符合条件执行完就退出循环
	        		if(tTestdata.getIntemp()!=YcAmount && tTestdata.getInh()!=YcAmount && 
	        				tTestdata.getOuttemp()!=YcAmount && tTestdata.getOuth()!=YcAmount){
	   	        	 BigDecimal gzInTemp = new BigDecimal(tAerationWarning.getInTemp()); //仓内温度阀值
	   	        	 BigDecimal gzInH = new BigDecimal(tAerationWarning.getInH()); //仓内湿度阀值
	   	        	 BigDecimal gzInOutH = new BigDecimal(tAerationWarning.getInOutH()); //仓外湿度差值(外-内，正数代表>内,负数代表<仓内)
	   	        	 BigDecimal gzInOutTemp = new BigDecimal(tAerationWarning.getInOutTemp()); //仓外温度差值
	   	        	 BigDecimal sjnwsdc = tTestdata.getOuth().subtract(tTestdata.getInh());//仓外湿-仓内湿(实际仓外湿度差值)
	   	        	 BigDecimal sjnwwdc = tTestdata.getOuttemp().subtract(tTestdata.getIntemp());//仓外温-仓内温(实际仓外温度差值)
	   	        	 
	   	        	 //用设置的规则-实际的 若<0 则要通风
	   	        	 int cnwCompare = gzInTemp.compareTo(tTestdata.getIntemp());//仓内温    -1表示小于,0是等于,1是大于
	   	        	 int cnsCompare = gzInH.compareTo(tTestdata.getInh());//仓内湿    -1表示小于,0是等于,1是大于
	   	        	 
	   	        	 BigDecimal zeroBig = new BigDecimal(0);
	   	        	 //判断实际的外湿度差值 是正数还是负数   实际的湿度差-0 
	   	        	 int sjsdc = sjnwsdc.compareTo(zeroBig);// -1表示负数,1是正数
	   	        	 int sjwdc = sjnwwdc.compareTo(zeroBig);// -1表示负数,1是正数

	   	        	int sdc = 0;
	   	        	int wdc = 0;
	   	        	 if(sjsdc == -1){//负数
		   	        	  sdc = sjnwsdc.compareTo(gzInOutH);//仓外温    -1表示小于,0是等于,1是大于
	   	        	 }else{
		   	        	  sdc = gzInOutH.compareTo(sjnwsdc);//仓外温    -1表示小于,0是等于,1是大于
	   	        	 }
	   	        	 
	   	        	 if(sjwdc == -1){//负数
		   	        	  wdc = sjnwwdc.compareTo(gzInOutTemp);//仓内温    -1表示小于,0是等于,1是大于
	   	        	 }else{
		   	        	  wdc = gzInOutTemp.compareTo(sjnwwdc);//仓内温    -1表示小于,0是等于,1是大于
	   	        	 }
	   	        	 
	   	        	 //满足设置的参数小于实际的  则要通风
	        		 if(cnwCompare == -1 && cnsCompare == -1 && sdc == -1 && wdc == -1){
	        			//查询该仓房下该设备类型下的所有的关闭着的设备
	        			 TCtldevinfoExample tCtldevinfoExample = new TCtldevinfoExample();
	        		    	tCtldevinfoExample.setDistinct(true);
	        		    	TCtldevinfoExample.Criteria criteria1 = tCtldevinfoExample.createCriteria();
	        		    	//组织id
	        				if (StringUtils.isNotEmpty(tAerationWarning.getOrgId().toString())) {
	        					criteria1.andOrgIdEqualTo(tAerationWarning.getOrgId());
	        				}
	        				//仓房编码
	        		        if (StringUtils.isNotEmpty(tAerationWarning.getvCfCode())) {
	        		            criteria1.andVcfcodeEqualTo(tAerationWarning.getvCfCode());
	        		        }
	        		        //设备类型
	        		        if (StringUtils.isNotEmpty(tAerationWarning.getvDeviceType())) {
	        		        	criteria1.andVdevkindcodeEqualTo(tAerationWarning.getvDeviceType());
	        		        }
	        		        criteria1.andDelFlagEqualTo(1);//未删除
	        		        criteria1.andVstatueEqualTo("0");//查询关闭的设备
	        		        List<TCtldevinfo> TCtldevinfoList = tCtldevinfoMapper.selectByExample(tCtldevinfoExample);
	        		        if(TCtldevinfoList!=null && TCtldevinfoList.size()>0){
	        		        	for (TCtldevinfo tCtldevinfo2 : TCtldevinfoList) {
	        		        		//发送打开的指令
	    		        			String dir = ConstUtils.directiveJoint("00", tCtldevinfo2.getVcfcode(), tCtldevinfo2.getVdevcode(), tCtldevinfo2.getVdevkindcode(), "0" + "1", "");
	    		                    System.out.println("打开的指令:"+dir);
	    		                    // 16进制字符串转byte数组
	    		                    byte[] bytes = HexConvertUtils.hexStringToByte(dir);
	    		                    // 发送指令
	    		                    String soc = socketClient.startClient(bytes);
	    		                    result = TypeEnum.resultDispose(soc);
	    		                    	if(TypeEnum.S_SOH.getDesc().equals(result)){
	    		                    		System.out.println("规则编号1:"+zntfId+"****"+tAerationWarning.getId());
	    			                    	TVentilation tVentilation = new TVentilation();
	    			                    	tVentilation.setId(uUidUtils.getCode());
	    			                    	tVentilation.setOrgId(tCtldevinfo2.getOrgId().toString());
	    			                    	tVentilation.setvCfCode(tCtldevinfo2.getVcfcode());//仓房
	    			                    	tVentilation.setOperationId(zntfId);//那个模式下的通风
	    			                    	tVentilation.setvDevName(tCtldevinfo2.getVdevname());//设备名称
	    			                    	tVentilation.setvDeviceCode(tCtldevinfo2.getVdevkindcode());//设备类型
	    			                    	tVentilation.setvDistinguishState(0);//通风状态下的通风
	    			                    	tVentilation.setvState(1);//打开通风
	    			                    	tVentilation.setvUpdateTime(new Date());
	    			                    	tVentilationMapper.insert(tVentilation);
	    			                    	
	    			                    	//改变设备表的打开状态
	    			                    	tCtldevinfo2.setVstatue("1");
	    			                    	tCtldevinfoMapper.updateByPrimaryKey(tCtldevinfo2);
	    			                    	
	    			                    	System.out.println("规则编号2:"+zntfId+"****"+tAerationWarning.getId());
	    			                    }else{
	    			                    	return ResponseEntity.failed(result);
	    			                    }
								}
	        		        	
	        		        }
	        		 }
	   	        	 
	   	        	 break;
	        		
	        		}
	        		
				}
	        	
	        }
			
	 }
	 if(tAerationWarning.getwState().equals("0")){ //规则是关闭状态
			/**
			 * 规则处于关闭状态，如果该仓房此时的该通风设备是开启的在规则条件下，则要关闭通风，否则不处理
			 */
		try{
			//判断是否是通风规则的通风
			TVentilationExample tVentilationExample = new TVentilationExample();
	    	tVentilationExample.setDistinct(true);
	    	TVentilationExample.Criteria criteria1 = tVentilationExample.createCriteria();
	        if (StringUtils.isNotEmpty(tAerationWarning.getvCfCode())) {
	            criteria1.andVCfCodeEqualTo(tAerationWarning.getvCfCode());
	        }
	        if (StringUtils.isNotEmpty(tAerationWarning.getvDeviceType())) {
	        	criteria1.andVDeviceCodeEqualTo(tAerationWarning.getvDeviceType());
	        }
	        if(StringUtils.isNotEmpty(tAerationWarning.getId())){
	        	criteria1.andOperationIdNotLike("JH");
	        }
	        if(StringUtils.isNotEmpty(tAerationWarning.getOrgId().toString())){
	        	criteria1.andOrgIdEqualTo(tAerationWarning.getOrgId().toString());
	        }
	        
	        List<TVentilation> tVentilationList = tVentilationMapper.selectByExample(tVentilationExample);
	        System.out.println("存在值");
	        if(tVentilationList!=null && tVentilationList.size()>0){ //存在通风规则
	        	//for (TVentilation tVentilation2 : tVentilationList) {
	        		//该规则下的设备是否处于打开状态
	        		TCtldevinfoExample tCtldevinfoExample = new TCtldevinfoExample();
	    	    	tCtldevinfoExample.setDistinct(true);
	    	    	TCtldevinfoExample.Criteria criteria = tCtldevinfoExample.createCriteria();
	    	    	//组织id
					if (StringUtils.isNotEmpty(tAerationWarning.getOrgId().toString())) {
						criteria.andOrgIdEqualTo(Integer.valueOf(tAerationWarning.getOrgId()));
					}
					//仓房编码
			        if (StringUtils.isNotEmpty(tAerationWarning.getvCfCode())) {
			            criteria.andVcfcodeEqualTo(tAerationWarning.getvCfCode());
			        }
			        //设备类型
			        if (StringUtils.isNotEmpty(tAerationWarning.getvDeviceType())) {
			        	criteria.andVdevkindcodeEqualTo(tAerationWarning.getvDeviceType());
			        }
	    	        criteria.andDelFlagEqualTo(1);//未删除
	    	        criteria.andVstatueEqualTo("1");//开启的设备
	    	        List<TCtldevinfo> TCtldevinfoList = tCtldevinfoMapper.selectByExample(tCtldevinfoExample);
	    	        if(TCtldevinfoList!=null && TCtldevinfoList.size()>0){ //存在通风的设备
	    	        	for (TCtldevinfo tCtldevinfo : TCtldevinfoList) {
	    	        			//String dir = ConstUtils.directiveJoint("00", tCtldevinfo.getVcfcode(), tCtldevinfo.getVdevcode(), tCtldevinfo.getVdevkindcode(), "0" + tCtldevinfo.getvState(), "");
	    	        			//发送关闭的指令
	    	        			String dir = ConstUtils.directiveJoint("00", tCtldevinfo.getVcfcode(), tCtldevinfo.getVdevcode(), tCtldevinfo.getVdevkindcode(), "0" + "0", "");
	    	                    System.out.println("关闭的指令:"+dir);
	    	                    // 16进制字符串转byte数组
	    	                    byte[] bytes = HexConvertUtils.hexStringToByte(dir);
	    	                    // 发送指令
	    	                    String soc = socketClient.startClient(bytes);
	    	                    result = TypeEnum.resultDispose(soc);
	    	                    	if(TypeEnum.S_SOH.getDesc().equals(result)){
	    		                    	TVentilation tVentilation = new TVentilation();
	    		                    	tVentilation.setId(uUidUtils.getCode());
	    		                    	tVentilation.setOrgId(tCtldevinfo.getOrgId().toString());
	    		                    	tVentilation.setvCfCode(tCtldevinfo.getVcfcode());//仓房
	    		                    	tVentilation.setOperationId(zntfId);//那个模式下的通风
	    		                    	tVentilation.setvDevName(tCtldevinfo.getVdevname());//设备名称
	    		                    	tVentilation.setvDeviceCode(tCtldevinfo.getVdevkindcode());//设备类型
	    		                    	tVentilation.setvDistinguishState(0);//通风状态下的通风
	    		                    	tVentilation.setvState(0);//关闭通风
	    		                    	tVentilation.setvUpdateTime(new Date());
	    		                    	tVentilationMapper.insert(tVentilation);
	    		                    	
	    		                    	//改变设备表的关闭状态
	    		                    	tCtldevinfo.setVstatue("0");
    			                    	tCtldevinfoMapper.updateByPrimaryKey(tCtldevinfo);
	    		                    	
	    		                    }
	    							Thread.currentThread().sleep(2000);
	    				}
	    	        }
				//}
	        }
	        
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return ResponseEntity.failed(result);
		 }
	 }
		return ResponseEntity.ok(result);
	}


	
	@Override
	public ResponseEntity<String> sceduleCheckTf(Integer orgId) {
		// TODO Auto-generated method stub
		String result = "";
		//查询该粮库有无通风规则
		List<TAerationWarning> warningList = tAerationWarningService.getList(orgId, null);
		if(warningList!=null && warningList.size()>0){
			for (TAerationWarning tAerationWarning : warningList) {
				  String zntfId = tAerationWarning.getId();
				if(tAerationWarning.getwState().equals("0")){ //规则是关闭状态
					//查询此时该仓房的该设备是否在通风规则的状态下通风，通风中就关闭，没有通风不处理

					//判断是否是通风规则的通风
        			TVentilationExample tVentilationExample = new TVentilationExample();
			    	tVentilationExample.setDistinct(true);
			    	TVentilationExample.Criteria criteria1 = tVentilationExample.createCriteria();
			        if (StringUtils.isNotEmpty(tAerationWarning.getvCfCode())) {
			            criteria1.andVCfCodeEqualTo(tAerationWarning.getvCfCode());
			        }
			        if (StringUtils.isNotEmpty(tAerationWarning.getvDeviceType())) {
			        	criteria1.andVDeviceCodeEqualTo(tAerationWarning.getvDeviceType());
			        }
			        if(StringUtils.isNotEmpty(tAerationWarning.getId())){
			        	//criteria1.andOperationIdEqualTo(tAerationWarning.getId());
			        	criteria1.andOperationIdNotLike("JH");
			        }
			        if(StringUtils.isNotEmpty(tAerationWarning.getOrgId().toString())){
			        	criteria1.andOrgIdEqualTo(tAerationWarning.getOrgId().toString());
			        }
			        
			        List<TVentilation> tVentilationList = tVentilationMapper.selectByExample(tVentilationExample);
			        //该通风规则有通风 判断是否为打开状态 打开状态 就关闭
			        if(tVentilationList!=null && tVentilationList.size()>0){
			        	//for (TVentilation tVentilation : tVentilationList) {
			        		TCtldevinfoExample tCtldevinfoExample = new TCtldevinfoExample();
					    	tCtldevinfoExample.setDistinct(true);
					    	TCtldevinfoExample.Criteria criteria = tCtldevinfoExample.createCriteria();
					    	//组织id
							if (StringUtils.isNotEmpty(tAerationWarning.getOrgId().toString())) {
								criteria.andOrgIdEqualTo(Integer.valueOf(tAerationWarning.getOrgId()));
							}
							//仓房编码
					        if (StringUtils.isNotEmpty(tAerationWarning.getvCfCode())) {
					            criteria.andVcfcodeEqualTo(tAerationWarning.getvCfCode());
					        }
					        //设备类型
					        if (StringUtils.isNotEmpty(tAerationWarning.getvDeviceType())) {
					        	criteria.andVdevkindcodeEqualTo(tAerationWarning.getvDeviceType());
					        }
					        criteria.andDelFlagEqualTo(1);//未删除
					        criteria.andVstatueEqualTo("1");//开启的设备
					        List<TCtldevinfo> TCtldevinfoList = tCtldevinfoMapper.selectByExample(tCtldevinfoExample);
					        if(TCtldevinfoList!=null && TCtldevinfoList.size()>0){
					        	for (TCtldevinfo tCtldevinfo : TCtldevinfoList) {
								        
					        			//String dir = ConstUtils.directiveJoint("00", tCtldevinfo.getVcfcode(), tCtldevinfo.getVdevcode(), tCtldevinfo.getVdevkindcode(), "0" + tCtldevinfo.getvState(), "");
					        			//发送关闭的指令
					        			String dir = ConstUtils.directiveJoint("00", tCtldevinfo.getVcfcode(), tCtldevinfo.getVdevcode(), tCtldevinfo.getVdevkindcode(), "0" + "0", "");
					                    System.out.println("关闭的指令:"+dir);
					                    // 16进制字符串转byte数组
					                    byte[] bytes = HexConvertUtils.hexStringToByte(dir);
					                    // 发送指令
					                    String soc = socketClient.startClient(bytes);
					                    result = TypeEnum.resultDispose(soc);
					                    	if(TypeEnum.S_SOH.getDesc().equals(result)){
						                    	TVentilation tVentila = new TVentilation();
						                    	tVentila.setId(uUidUtils.getCode());
						                    	tVentila.setOrgId(tCtldevinfo.getOrgId().toString());
						                    	tVentila.setvCfCode(tCtldevinfo.getVcfcode());//仓房
						                    	tVentila.setOperationId(zntfId);//那个模式下的通风
						                    	tVentila.setvDevName(tCtldevinfo.getVdevname());//设备名称
						                    	tVentila.setvDeviceCode(tCtldevinfo.getVdevkindcode());//设备类型
						                    	tVentila.setvDistinguishState(0);//通风状态下的通风
						                    	tVentila.setvState(0);//关闭通风
						                    	tVentila.setvUpdateTime(new Date());
						                    	tVentilationMapper.insert(tVentila);
						                    	//改变设备表的关闭状态
			    		                    	tCtldevinfo.setVstatue("0");
		    			                    	tCtldevinfoMapper.updateByPrimaryKey(tCtldevinfo);
						                    }else{
						                    	return ResponseEntity.failed(result);
						                    }
								}
					        }
						//}
			        }
				}else if(tAerationWarning.getwState().equals("1")){//规则是打开状态
					/**判断是否在通风规则下通风
					 * 是: 则要根据设置的通风间隔时间去进行温湿度的检测，如果符合条件则继续通风，否则停止通风
						        否:1、判断该仓房最近2小时之内的温湿度情况与规则进行对比，全部满足就通风，否则不通风
							  (如果通风，则要根据设置的通风间隔时间去进行温湿度的检测，如果符合条件则继续通风，否则停止通风)
					 */
					
					//判断是否是通风规则的通风
        			TVentilationExample tVentilationExample = new TVentilationExample();
			    	tVentilationExample.setDistinct(true);
			    	TVentilationExample.Criteria criteria1 = tVentilationExample.createCriteria();
			        if (StringUtils.isNotEmpty(tAerationWarning.getvCfCode())) {
			            criteria1.andVCfCodeEqualTo(tAerationWarning.getvCfCode());
			        }
			        if (StringUtils.isNotEmpty(tAerationWarning.getvDeviceType())) {
			        	criteria1.andVDeviceCodeEqualTo(tAerationWarning.getvDeviceType());
			        }
			        if(StringUtils.isNotEmpty(tAerationWarning.getId())){
			        	//criteria1.andOperationIdEqualTo(tAerationWarning.getId());
			        	criteria1.andOperationIdNotLike("JH");
			        }
			        if(StringUtils.isNotEmpty(tAerationWarning.getOrgId().toString())){
			        	criteria1.andOrgIdEqualTo(tAerationWarning.getOrgId().toString());
			        }
			        
			        List<TVentilation> tVentilationList = tVentilationMapper.selectByExample(tVentilationExample);
			        if(tVentilationList!=null && tVentilationList.size()>0){
			        	/**
			        	 * 有通风规则 判断 是否在通风状态
			        	 */
			        	//for (TVentilation tVentilation : tVentilationList) {
			        		TCtldevinfoExample tCtldevinfoExample = new TCtldevinfoExample();
		    		    	tCtldevinfoExample.setDistinct(true);
		    		    	TCtldevinfoExample.Criteria criteria2 = tCtldevinfoExample.createCriteria();
		    		    	//组织id
		    				if (StringUtils.isNotEmpty(tAerationWarning.getOrgId().toString())) {
		    					criteria2.andOrgIdEqualTo(Integer.valueOf(tAerationWarning.getOrgId()));
		    				}
		    		        //仓房编码
					        if (StringUtils.isNotEmpty(tAerationWarning.getvCfCode())) {
					            criteria2.andVcfcodeEqualTo(tAerationWarning.getvCfCode());
					        }
					        //设备类型
					        if (StringUtils.isNotEmpty(tAerationWarning.getvDeviceType())) {
					        	criteria2.andVdevkindcodeEqualTo(tAerationWarning.getvDeviceType());
					        }
		    		        criteria2.andDelFlagEqualTo(1);//未删除
		    		        List<TCtldevinfo> TCtldevinfoList = tCtldevinfoMapper.selectByExample(tCtldevinfoExample);
		    		        if(TCtldevinfoList!=null && TCtldevinfoList.size()>0){
		    		        	for (TCtldevinfo tCtldevinfo2 : TCtldevinfoList) {
		    		        		
		    		        		if(tCtldevinfo2.getVstatue().equals("0")){ //关闭，不在通风状态中
		    		        			/**
		    		        			 * 1、判断该仓房最近2小时之内的温湿度情况与规则进行对比，全部满足就通风，否则不通风
									      2、如果通风，则要根据设置的通风间隔时间去进行温湿度的检测，如果符合条件则继续通风，否则停止通风
		    		        			 */
		    								 TTestdataExample testdataExample = new TTestdataExample();
				    		   			        testdataExample.setDistinct(true);
				    		   			        TTestdataExample.Criteria criteria = testdataExample.createCriteria();
				    		   			        //组织id
				    		   			        if (StringUtils.isNotEmpty(tAerationWarning.getOrgId().toString())) {
				    		   			            criteria.andOrgIdEqualTo(tAerationWarning.getOrgId().toString());
				    		   			        }
				    		   			        //仓房
				    		   			        if (StringUtils.isNotEmpty(tAerationWarning.getvCfCode())) {
				    		   			            criteria.andStorehouseEqualTo(tAerationWarning.getvCfCode());
				    		   			        }
				    		   			        //获取两小时之内的粮情数据
				    		   			        Date date=new Date(); 
				    		   			        Calendar calendar = Calendar.getInstance(); 
				    		   			        calendar.setTime(date);
				    		   			        calendar.add(Calendar.HOUR_OF_DAY, -2);  
				    		   			        Date date1 = calendar.getTime();  
				    		   			        criteria.andTimeBetween(date1, date);
				    		   			        //粮情
				    		   			        if (StringUtils.isNotEmpty("0")) {
				    		   			            criteria.andIlqYqEqualTo("0");
				    		   			        }
				    		   			        testdataExample.setOrderByClause("time desc");
				    		   			        List<TTestdata> tTestList = tTestdataMapper.selectByExample(testdataExample);

				    					        if(tTestList!=null && tTestList.size()>0){
				    					        	 BigDecimal YcAmount = new BigDecimal("250"); //异常的
				    					        	for (TTestdata tTestdata : tTestList) {//查询出两小时之内的数据，取最近的一条数据都为正常的 自取一条符合条件执行完就退出循环
				    					        		if(tTestdata.getIntemp()!=YcAmount && tTestdata.getInh()!=YcAmount && 
				    					        				tTestdata.getOuttemp()!=YcAmount && tTestdata.getOuth()!=YcAmount){
				    					   	        	 BigDecimal gzInTemp = new BigDecimal(tAerationWarning.getInTemp()); //仓内温度阀值
				    					   	        	 BigDecimal gzInH = new BigDecimal(tAerationWarning.getInH()); //仓内湿度阀值
				    					   	        	 BigDecimal gzInOutH = new BigDecimal(tAerationWarning.getInOutH()); //仓外湿度差值(外-内，正数代表>内,负数代表<仓内)
				    					   	        	 BigDecimal gzInOutTemp = new BigDecimal(tAerationWarning.getInOutTemp()); //仓外温度差值
				    					   	        	 BigDecimal sjnwsdc = tTestdata.getOuth().subtract(tTestdata.getInh());//仓外湿-仓内湿(实际仓外湿度差值)
				    					   	        	 BigDecimal sjnwwdc = tTestdata.getOuttemp().subtract(tTestdata.getIntemp());//仓外温-仓内温(实际仓外温度差值)
				    					   	        	 
				    					   	        	 //用设置的规则-实际的 若<0 则要通风
				    					   	        	 int cnwCompare = gzInTemp.compareTo(tTestdata.getIntemp());//仓内温    -1表示小于,0是等于,1是大于
				    					   	        	 int cnsCompare = gzInH.compareTo(tTestdata.getInh());//仓内湿    -1表示小于,0是等于,1是大于
				    					   	        	 
				    					   	        	BigDecimal zeroBig = new BigDecimal(0);
				    					   	        	 //判断实际的外湿度差值 是正数还是负数   实际的湿度差-0 
				    					   	        	 int sjsdc = sjnwsdc.compareTo(zeroBig);// -1表示负数,1是正数
				    					   	        	 int sjwdc = sjnwwdc.compareTo(zeroBig);// -1表示负数,1是正数

				    					   	        	int sdc = 0;
				    					   	        	int wdc = 0;
				    					   	        	 if(sjsdc == -1){//负数
				    						   	        	  sdc = sjnwsdc.compareTo(gzInOutH);//仓外温    -1表示小于,0是等于,1是大于
				    					   	        	 }else{
				    						   	        	  sdc = gzInOutH.compareTo(sjnwsdc);//仓外温    -1表示小于,0是等于,1是大于
				    					   	        	 }
				    					   	        	 
				    					   	        	 if(sjwdc == -1){//负数
				    						   	        	  wdc = sjnwwdc.compareTo(gzInOutTemp);//仓内温    -1表示小于,0是等于,1是大于
				    					   	        	 }else{
				    						   	        	  wdc = gzInOutTemp.compareTo(sjnwwdc);//仓内温    -1表示小于,0是等于,1是大于
				    					   	        	 }
				    					   	        	 
				    					   	        	 //满足设置的参数小于实际的  则要通风
				    					        		 if(cnwCompare == -1 && cnsCompare == -1 && sdc == -1 && wdc == -1){
							        		        		//发送打开的指令
							    		        			String dir = ConstUtils.directiveJoint("00", tCtldevinfo2.getVcfcode(), tCtldevinfo2.getVdevcode(), tCtldevinfo2.getVdevkindcode(), "0" + "1", "");
							    		                    System.out.println("打开的指令:"+dir);
							    		                    // 16进制字符串转byte数组
							    		                    byte[] bytes = HexConvertUtils.hexStringToByte(dir);
							    		                    // 发送指令
							    		                    String soc = socketClient.startClient(bytes);
							    		                    result = TypeEnum.resultDispose(soc);
							    		                    	if(TypeEnum.S_SOH.getDesc().equals(result)){
							    			                    	TVentilation tVentila = new TVentilation();
							    			                    	tVentila.setId(uUidUtils.getCode());
							    			                    	tVentila.setOrgId(tCtldevinfo2.getOrgId().toString());
							    			                    	tVentila.setvCfCode(tCtldevinfo2.getVcfcode());//仓房
							    			                    	tVentila.setOperationId(zntfId);//那个模式下的通风
							    			                    	tVentila.setvDevName(tCtldevinfo2.getVdevname());//设备名称
							    			                    	tVentila.setvDeviceCode(tCtldevinfo2.getVdevkindcode());//设备类型
							    			                    	tVentila.setvDistinguishState(0);//通风状态下的通风
							    			                    	tVentila.setvState(1);//打开通风
							    			                    	tVentila.setvUpdateTime(new Date());
							    			                    	tVentilationMapper.insert(tVentila);
							    			                    	
							    			                    	//改变设备表的打开状态
							    			                    	tCtldevinfo2.setVstatue("1");
							    			                    	tCtldevinfoMapper.updateByPrimaryKey(tCtldevinfo2);
							    			                    	
							    			                    }else{
							    			                    	return ResponseEntity.failed(result);
							    			                    }
				    					        		        	
				    					        		 }
				    					        		 break;
				    					        		
				    					        		}
				    					        		
				    								}
				    					        	
				    					        }
		    		   				     continue;
		    		        		}else if(tCtldevinfo2.getVstatue().equals("1")){ //打开 通风中
		    		        			//则要根据设置的通风间隔时间去进行温湿度的检测，如果符合条件则继续通风，否则停止通风
		    		        			TTestdataExample testdataExample = new TTestdataExample();
		    		   			        testdataExample.setDistinct(true);
		    		   			        TTestdataExample.Criteria criteria = testdataExample.createCriteria();
		    		   			        //组织id
		    		   			        if (StringUtils.isNotEmpty(tAerationWarning.getOrgId().toString())) {
		    		   			            criteria.andOrgIdEqualTo(tAerationWarning.getOrgId().toString());
		    		   			        }
		    		   			        //仓房
		    		   			        if (StringUtils.isNotEmpty(tAerationWarning.getvCfCode())) {
		    		   			            criteria.andStorehouseEqualTo(tAerationWarning.getvCfCode());
		    		   			        }
		    		   			        //获取两小时之内的粮情数据
		    		   			        Date date=new Date(); 
		    		   			        Calendar calendar = Calendar.getInstance(); 
		    		   			        Integer jgsj = Integer.valueOf(tAerationWarning.getDetectionTime())*60;
		    		   			        calendar.setTime(date);
		    		   			        calendar.add(Calendar.MINUTE, -jgsj); //分钟
		    		   			        Date date1 = calendar.getTime();  
		    		   			        criteria.andTimeBetween(date1, date);
		    		   			        //粮情
		    		   			        if (StringUtils.isNotEmpty("0")) {
		    		   			            criteria.andIlqYqEqualTo("0");
		    		   			        }
		    		   			        testdataExample.setOrderByClause("time desc");
		    		   			        List<TTestdata> tTestList = tTestdataMapper.selectByExample(testdataExample);
		    		   			     if(tTestList!=null && tTestList.size()>0){
	    					        	 BigDecimal YcAmount = new BigDecimal("250"); //异常的
	    					        	for (TTestdata tTestdata : tTestList) {//查询出两小时之内的数据，取最近的一条数据都为正常的 自取一条符合条件执行完就退出循环
	    					        		if(tTestdata.getIntemp()!=YcAmount && tTestdata.getInh()!=YcAmount && 
	    					        				tTestdata.getOuttemp()!=YcAmount && tTestdata.getOuth()!=YcAmount){
	    					   	        	 // BigDecimal gzInTemp = new BigDecimal(tAerationWarning.getInTemp()); //仓内温度阀值
	    					   	        	 //BigDecimal gzInH = new BigDecimal(tAerationWarning.getInH()); //仓内湿度阀值
	    					   	        	 //BigDecimal gzInOutH = new BigDecimal(tAerationWarning.getInOutH()); //仓外湿度差值(外-内，正数代表>内,负数代表<仓内)
	    					   	        	 //BigDecimal gzInOutTemp = new BigDecimal(tAerationWarning.getInOutTemp()); //仓外温度差值
	    					   	        	 //BigDecimal sjnwsdc = tTestdata.getOuth().subtract(tTestdata.getInh());//仓外湿-仓内湿(实际仓外湿度差值)
	    					   	        	 //BigDecimal sjnwwdc = tTestdata.getOuttemp().subtract(tTestdata.getIntemp());//仓外温-仓内温(实际仓外温度差值)
	    					   	        	 
	    					   	        	 BigDecimal gzAfterInTemp = new BigDecimal(tAerationWarning.getAfterInTemp()); //通风后仓内温度阀值
	    					   	        	 BigDecimal gzAfterInH = new BigDecimal(tAerationWarning.getAfterInH()); //通风后仓内湿度阀值
	    					   	        	 //用设置的规则-实际的 若<0 则要通风   若>=0关闭
	    					   	        	 int cnwCompare = gzAfterInTemp.compareTo(tTestdata.getIntemp());//仓内温    -1表示小于,0是等于,1是大于
	    					   	        	 int cnsCompare = gzAfterInH.compareTo(tTestdata.getInh());//仓内湿    -1表示小于,0是等于,1是大于
	    					   	        	 
	    			
	    					   	        	 //通风后的设置温度大于或等于实际温度，停止通风
	    					        		 if(cnwCompare != -1 && cnsCompare != -1){
				        		        		//发送关闭的指令
	    					        			 String dir = ConstUtils.directiveJoint("00", tCtldevinfo2.getVcfcode(), tCtldevinfo2.getVdevcode(), tCtldevinfo2.getVdevkindcode(), "0" + "0", "");
	    				    	                 System.out.println("关闭的指令:"+dir);
				    		                    // 16进制字符串转byte数组
				    		                    byte[] bytes = HexConvertUtils.hexStringToByte(dir);
				    		                    // 发送指令
				    		                    String soc = socketClient.startClient(bytes);
				    		                    result = TypeEnum.resultDispose(soc);
				    		                    	if(TypeEnum.S_SOH.getDesc().equals(result)){
				    			                    	TVentilation tVentila = new TVentilation();
				    			                    	tVentila.setId(uUidUtils.getCode());
				    			                    	tVentila.setOrgId(tCtldevinfo2.getOrgId().toString());
				    			                    	tVentila.setvCfCode(tCtldevinfo2.getVcfcode());//仓房
				    			                    	tVentila.setOperationId(zntfId);//那个模式下的通风
				    			                    	tVentila.setvDevName(tCtldevinfo2.getVdevname());//设备名称
				    			                    	tVentila.setvDeviceCode(tCtldevinfo2.getVdevkindcode());//设备类型
				    			                    	tVentila.setvDistinguishState(0);//通风状态下的通风
				    			                    	tVentila.setvState(0);//关闭通风
				    			                    	tVentila.setvUpdateTime(new Date());
				    			                    	tVentilationMapper.insert(tVentila);
				    			                    	
				    			                    	//改变设备表的关闭状态
				    			                    	tCtldevinfo2.setVstatue("0");
				    			                    	tCtldevinfoMapper.updateByPrimaryKey(tCtldevinfo2);
				    			                    	
				    			                    }else{
				    			                    	return ResponseEntity.failed(result);
				    			                    }
	    					        		        	
	    					        		 }
	    					        		  break;
	    					        		}
	    					        		
	    								}
	    					        	
	    					        }
		    		        		}
								}
		    		        }
						//}
			        	
			        }
				}
			}
		}
		return ResponseEntity.ok(result);
	}

}
