package com.chinaitop.depot.intelligent.ventilation.service.impl;





import java.util.List;

import javax.annotation.Resource;

import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.chinaitop.depot.intelligent.utils.JsonToObjectUtils;
import com.chinaitop.depot.intelligent.utils.UuidUtils;
import com.chinaitop.depot.intelligent.ventilation.mapper.TAerationWarningMapper;
import com.chinaitop.depot.intelligent.ventilation.model.TAerationWarning;
import com.chinaitop.depot.intelligent.ventilation.model.TAerationWarningExample;
import com.chinaitop.depot.intelligent.ventilation.service.TAerationWarningService;



@Service
public class TAerationWarningServiceImpl implements TAerationWarningService {
    @Autowired
    private TAerationWarningMapper tAerationWarningMapper;
    @Resource
    private UuidUtils uUidUtils;

	@Override
	public void save(String aerationRuleJson) {
		// TODO Auto-generated method stub
		if (StringUtils.isNotBlank(aerationRuleJson)) {
			TAerationWarning tAerationWarning = (TAerationWarning) JsonToObjectUtils.jsonToObject(aerationRuleJson, "com.chinaitop.depot.intelligent.ventilation.model.TAerationWarning");
			if(tAerationWarning.getId()!=null){//修改
				tAerationWarningMapper.updateByPrimaryKey(tAerationWarning);
			}else{//新增
				tAerationWarning.setId(uUidUtils.getCode());
				tAerationWarning.setDelFlag(1);//未删除
				tAerationWarningMapper.insert(tAerationWarning);
			}
			
        }
	}

	@Override
	public List<TAerationWarning> getList(Integer orgId, String vCfCode) {
		// TODO Auto-generated method stub
		TAerationWarningExample tAerationWarningExample = new TAerationWarningExample();
		TAerationWarningExample.Criteria criteria = tAerationWarningExample.createCriteria();
		if (StringUtils.isNotEmpty(orgId.toString())) {
			criteria.andOrgIdEqualTo(orgId);
		}
        if (StringUtils.isNotEmpty(vCfCode)) {
            criteria.andVCfCodeEqualTo(vCfCode);
        }
        criteria.andDelFlagEqualTo(1);//未删除
        tAerationWarningExample.setOrderByClause("create_time desc");
        return tAerationWarningMapper.selectByExample(tAerationWarningExample);
	}

	@Override
	public TAerationWarning getById(String id) {
		// TODO Auto-generated method stub
		return tAerationWarningMapper.selectByPrimaryKey(id);
	}

	@Override
	public int deleteById(String id) {
		// TODO Auto-generated method stub
		return tAerationWarningMapper.deleteByPrimaryKey(id);
	}

    

	
	

   

   

}
